Index: src/view/NoteTrackV.cpp
===================================================================
--- src/view/NoteTrackV.cpp	(revision 0)
+++ src/view/NoteTrackV.cpp	(working copy)
@@ -0,0 +1,699 @@
+#include "../Audacity.h"
+#include "../TrackArtist.h"
+#ifdef USE_MIDI
+#include "../NoteTrack.h"
+#endif // USE_MIDI
+
+NoteTrackV::NoteTrackV(void):
+TrackV()
+{
+}
+
+NoteTrackV::~NoteTrackV(void)
+{
+}
+
+#ifdef USE_MIDI
+/*
+const int octaveHeight = 62;
+const int blackPos[5] = { 6, 16, 32, 42, 52 };
+const int whitePos[7] = { 0, 9, 17, 26, 35, 44, 53 };
+const int notePos[12] = { 1, 6, 11, 16, 21, 27,
+                        32, 37, 42, 47, 52, 57 };
+
+// map pitch number to window coordinate of the *top* of the note
+// Note the "free" variable bottom, which is assumed to be a local 
+// variable set to the offset of pitch 0 relative to the window
+#define IPITCH_TO_Y(t, p) (bottom - ((p) / 12) * octaveHeight - \
+                          notePos[(p) % 12] - (t)->GetPitchHeight())
+
+// GetBottom is called from a couple of places to compute the hypothetical
+// coordinate of the bottom of pitch 0 in window coordinates. See
+// IPITCH_TO_Y above, which computes coordinates relative to GetBottom()
+// Note the -NOTE_MARGIN, which leaves a little margin to draw notes that
+// are out of bounds. I'm not sure why the -2 is necessary.
+int TrackArtist::GetBottom(NoteTrack *t, const wxRect &r)
+{
+   int bottomNote = t->GetBottomNote();
+   int bottom = r.y + r.height - 2 - t->GetNoteMargin() +
+          ((bottomNote / 12) * octaveHeight + notePos[bottomNote % 12]);
+   return bottom;
+
+}
+*/
+#endif // USE_MIDI
+
+#ifdef USE_MIDI
+/*
+Note: recall that Allegro attributes end in a type identifying letter.
+
+In addition to standard notes, an Allegro_Note can denote a graphic.
+A graphic is a note with a loud of zero (for quick testing) and an
+attribute named "shapea" set to one of the following atoms:
+    line
+        from (time, pitch) to (time+dur, y1r), where y1r is an
+          attribute
+    rectangle
+        from (time, pitch) to (time+dur, y1r), where y1r is an
+          attribute
+    triangle
+        coordinates are (time, pitch), (x1r, y1r), (x2r, y2r)
+        dur must be the max of x1r-time, x2r-time
+    polygon
+        coordinates are (time, pitch), (x1r, y1r), (x2r, y2r),
+          (x3r, y3r), ... are coordinates (since we cannot represent
+          arrays as attribute values, we just generate as many
+          attribute names as we need)
+        dur must be the max of xNr-time for all N
+    oval
+        similar to rectangle
+        Note: this oval has horizontal and vertical axes only
+    text
+        drawn at (time, pitch)
+        duration should be zero (text is clipped based on time and duration,
+          NOT based on actual coordinates)
+
+and optional attributes as follows:
+    linecolori is 0x00rrggbb format color for line or text foreground
+    fillcolori is 0x00rrggbb format color for fill or text background
+    linethicki is line thickness in pixels, 0 for no line
+    filll is true to fill rectangle or draw text background (default is false)
+    fonta is one of ['roman', 'swiss', 'modern'] (font, otherwise use default)
+    weighta may be 'bold' (font) (default is normal)
+    sizei is font size (default is 8)
+    justifys is a string containing two letters, a horizontal code and a
+      vertical code. The horizontal code is as follows:
+        l: the coordinate is to the left of the string (default)
+        c: the coordinate is at the center of the string
+        r: the coordinate is at the right of the string
+      The vertical code is as follows:
+        t: the coordinate is at the top of the string
+        c: the coordinate is at the center of the string
+        b: the coordinate is at the bottom of the string
+        d: the coordinate is at the baseline of the string (default)
+      Thus, -justifys:"lt" places the left top of the string at the point
+        given by (pitch, time). The default value is "ld".
+*/
+
+#define TIME_TO_X(t) (r.x + (int) (((t) - h) * pps))
+#define X_TO_TIME(xx) (((xx) - r.x) / pps + h)
+
+// CLIP(x) changes x to lie between +/- CLIP_MAX due to graphics display problems
+//  with very large coordinate values (this happens when you zoom in very far)
+//  This will cause incorrect things to be displayed, but at these levels of zoom
+//  you will only see a small fraction of the overall shape. Note that rectangles
+//  and lines are clipped in a way that preserves correct graphics, so in
+//  particular, line plots will be correct at any zoom (limited by floating point
+//  precision).
+#define CLIP_MAX 16000
+#define CLIP(x) { long c = (x); if (c < -CLIP_MAX) c = -CLIP_MAX; \
+                  if (c > CLIP_MAX) c = CLIP_MAX; (x) = c; }
+
+#define RED(i) ( unsigned char )( (((i) >> 16) & 0xff) )
+#define GREEN(i) ( unsigned char )( (((i) >> 8) & 0xff) )
+#define BLUE(i) ( unsigned char )( ((i) & 0xff) )
+
+//#define PITCH_TO_Y(p) (r.y + r.height - int(pitchht * ((p) + 0.5 - pitch0) + 0.5))
+
+#ifdef USE_MIDI
+
+/*
+int PitchToY(double p, int bottom)
+{
+   int octave = (((int) (p + 0.5)) / 12);
+   int n = ((int) (p + 0.5)) % 12;
+   
+   return IPITCH_TO_Y((int) (p + 0.5));
+   // was: bottom - octave * octaveHeight - notePos[n] - 4;
+}
+*/
+
+#endif // USE_MIDI
+/* Declare Static functions */
+static const char *IsShape(Alg_note_ptr note);
+static double LookupRealAttribute(Alg_note_ptr note, Alg_attribute attr, double def);
+static long LookupIntAttribute(Alg_note_ptr note, Alg_attribute attr, long def);
+static bool LookupLogicalAttribute(Alg_note_ptr note, Alg_attribute attr, bool def);
+static const char *LookupStringAttribute(Alg_note_ptr note, Alg_attribute attr, const char *def);
+static const char *LookupAtomAttribute(Alg_note_ptr note, Alg_attribute attr, char *def);
+//static int PITCH_TO_Y(double p, int bottom);
+
+/* DrawNoteTrack:
+Draws a piano-roll style display of sequence data with added
+graphics. Since there may be notes outside of the display region,
+reserve a half-note-height margin at the top and bottom of the
+window and draw out-of-bounds notes here instead.
+*/
+void NoteTrackV::DrawNoteTrack(NoteTrack *track,
+                                wxDC & dc,
+                                const wxRect & r,
+                                const ViewInfo *viewInfo,
+                                bool muted)
+{
+   SonifyBeginNoteBackground();
+   double h = viewInfo->h;
+   double pps = viewInfo->zoom;
+   double sel0 = viewInfo->sel0;
+   double sel1 = viewInfo->sel1;
+
+   double h1 = X_TO_TIME(r.x + r.width);
+
+   Alg_seq_ptr seq = track->mSeq;
+   if (!seq) {
+      assert(track->mSerializationBuffer);
+      Alg_track_ptr alg_track = seq->unserialize(track->mSerializationBuffer,
+            track->mSerializationLength);
+      assert(alg_track->get_type() == 's');
+      track->mSeq = seq = (Alg_seq_ptr) alg_track;
+      free(track->mSerializationBuffer);
+      track->mSerializationBuffer = NULL;
+   }
+   assert(seq);
+   int visibleChannels = track->mVisibleChannels;
+
+   if (!track->GetSelected())
+      sel0 = sel1 = 0.0;
+
+   // reserve 1/2 note height at top and bottom of track for
+   // out-of-bounds notes
+   int numPitches = (r.height) / track->GetPitchHeight();
+   if (numPitches < 0) numPitches = 0; // cannot be negative
+
+   // bottom is the hypothetical location of the bottom of pitch 0 relative to 
+   // the top of the clipping region r: r.height - PITCH_HEIGHT/2 is where the 
+   // bottomNote is displayed, and to that
+   // we add the height of bottomNote from the position of pitch 0
+   track->PrepareIPitchToY(r);
+
+   // Background comes in 6 colors:
+   //   214, 214,214 -- unselected white keys
+   //   192,192,192 -- unselected black keys
+   //   170,170,170 -- unselected bar lines
+   //   165,165,190 -- selected white keys
+   //   148,148,170 -- selected black keys
+   //   131,131,150 -- selected bar lines
+   wxPen blackStripePen;
+   blackStripePen.SetColour(192, 192, 192);
+   wxBrush blackStripeBrush;
+   blackStripeBrush.SetColour(192, 192, 192);
+   wxPen barLinePen;
+   barLinePen.SetColour(170, 170, 170);
+
+   DrawNoteBackground(track, dc, r, r, viewInfo, blankBrush, blankPen, 
+                      blackStripeBrush, blackStripePen, barLinePen);
+
+   dc.SetClippingRegion(r);
+
+   // Draw the selection background
+   // First, the white keys, as a single rectangle
+   // In other words fill the selection area with selectedWhiteKeyPen
+   wxRect selBG;
+   selBG.y = r.y;
+   selBG.height = r.height;
+   selBG.x = TIME_TO_X(sel0);
+   selBG.width = TIME_TO_X(sel1) - TIME_TO_X(sel0);
+
+   wxPen selectedWhiteKeyPen;
+   selectedWhiteKeyPen.SetColour(165, 165, 190);
+   dc.SetPen(selectedWhiteKeyPen);
+   
+   wxBrush selectedWhiteKeyBrush;
+   selectedWhiteKeyBrush.SetColour(165, 165, 190);
+   // Then, the black keys and octave stripes, as smaller rectangles
+   wxPen selectedBlackKeyPen;
+   selectedBlackKeyPen.SetColour(148, 148, 170);
+   wxBrush selectedBlackKeyBrush;
+   selectedBlackKeyBrush.SetColour(148, 148, 170);
+   wxPen selectedBarLinePen;
+   selectedBarLinePen.SetColour(131, 131, 150);
+
+   DrawNoteBackground(track, dc, r, selBG, viewInfo,
+                      selectedWhiteKeyBrush, selectedWhiteKeyPen,
+                      selectedBlackKeyBrush, selectedBlackKeyPen,
+                      selectedBarLinePen);
+   SonifyEndNoteBackground();
+   SonifyBeginNoteForeground();
+   int marg = track->GetNoteMargin();
+
+   // NOTE: it would be better to put this in some global initialization
+   // function rather than do lookups every time.
+   Alg_attribute line = symbol_table.insert_string("line");
+   Alg_attribute rectangle = symbol_table.insert_string("rectangle");
+   Alg_attribute triangle = symbol_table.insert_string("triangle");
+   Alg_attribute polygon = symbol_table.insert_string("polygon");
+   Alg_attribute oval = symbol_table.insert_string("oval");
+   Alg_attribute text = symbol_table.insert_string("text");
+   Alg_attribute texts = symbol_table.insert_string("texts");
+   Alg_attribute x1r = symbol_table.insert_string("x1r");
+   Alg_attribute x2r = symbol_table.insert_string("x2r");
+   Alg_attribute y1r = symbol_table.insert_string("y1r");
+   Alg_attribute y2r = symbol_table.insert_string("y2r");
+   Alg_attribute linecolori = symbol_table.insert_string("linecolori");
+   Alg_attribute fillcolori = symbol_table.insert_string("fillcolori");
+   Alg_attribute linethicki = symbol_table.insert_string("linethicki");
+   Alg_attribute filll = symbol_table.insert_string("filll");
+   Alg_attribute fonta = symbol_table.insert_string("fonta");
+   Alg_attribute roman = symbol_table.insert_string("roman");
+   Alg_attribute swiss = symbol_table.insert_string("swiss");
+   Alg_attribute modern = symbol_table.insert_string("modern");
+   Alg_attribute weighta = symbol_table.insert_string("weighta");
+   Alg_attribute bold = symbol_table.insert_string("bold");
+   Alg_attribute sizei = symbol_table.insert_string("sizei");
+   Alg_attribute justifys = symbol_table.insert_string("justifys");
+
+   // We want to draw in seconds, so we need to convert to seconds
+   seq->convert_to_seconds();
+
+   Alg_iterator iterator(seq, false);
+   iterator.begin();
+   //for every event
+   Alg_event_ptr evt;
+   while ((evt = iterator.next())) {
+      if (evt->get_type() == 'n') { // 'n' means a note
+         Alg_note_ptr note = (Alg_note_ptr) evt;
+         // if the note's channel is visible
+         if (visibleChannels & (1 << (evt->chan & 15))) {
+            double x = note->time + track->GetOffset();
+            double x1 = x + note->dur;
+            if (x < h1 && x1 > h) { // omit if outside box
+               const char *shape = NULL;
+               if (note->loud > 0.0 || !(shape = IsShape(note))) {
+                  wxRect nr; // "note rectangle"
+                  nr.y = track->PitchToY(note->pitch);
+                  nr.height = track->GetPitchHeight();
+
+                  nr.x = r.x + (int) ((x - h) * pps);
+                  nr.width = (int) ((note->dur * pps) + 0.5);
+
+                  if (nr.x + nr.width >= r.x && nr.x < r.x + r.width) {
+                     if (nr.x < r.x) {
+                        nr.width -= (r.x - nr.x);
+                        nr.x = r.x;
+                     }
+                     if (nr.x + nr.width > r.x + r.width) // clip on right
+                        nr.width = r.x + r.width - nr.x;
+
+                     if (nr.y + nr.height < r.y + marg + 3) {
+                         // too high for window
+                         nr.y = r.y;
+                         nr.height = marg;
+                         dc.SetBrush(*wxBLACK_BRUSH);
+                         dc.SetPen(*wxBLACK_PEN);
+                         dc.DrawRectangle(nr);
+                     } else if (nr.y >= r.y + r.height - marg - 1) { 
+                         // too low for window
+                         nr.y = r.y + r.height - marg;
+                         nr.height = marg;
+                         dc.SetBrush(*wxBLACK_BRUSH);
+                         dc.SetPen(*wxBLACK_PEN);
+                         dc.DrawRectangle(nr);
+                     } else {
+                        if (nr.y + nr.height > r.y + r.height - marg)
+                           nr.height = r.y + r.height - nr.y;
+                        if (nr.y < r.y + marg) {
+                           int offset = r.y + marg - nr.y;
+                           nr.height -= offset;
+                           nr.y += offset;
+                        }
+                        // nr.y += r.y;
+                        if (muted)
+                           AColor::LightMIDIChannel(&dc, note->chan + 1);
+                        else
+                           AColor::MIDIChannel(&dc, note->chan + 1);
+                        dc.DrawRectangle(nr);
+                        if (track->GetPitchHeight() > 2) {
+                           AColor::LightMIDIChannel(&dc, note->chan + 1);
+                           AColor::Line(dc, nr.x, nr.y, nr.x + nr.width-2, nr.y);
+                           AColor::Line(dc, nr.x, nr.y, nr.x, nr.y + nr.height-2);
+                           AColor::DarkMIDIChannel(&dc, note->chan + 1);
+                           AColor::Line(dc, nr.x+nr.width-1, nr.y,
+                                 nr.x+nr.width-1, nr.y+nr.height-1);
+                           AColor::Line(dc, nr.x, nr.y+nr.height-1,
+                                 nr.x+nr.width-1, nr.y+nr.height-1);
+                        }
+//                        }
+                     }
+                  }
+               } else if (shape) {
+                  // draw a shape according to attributes
+                  // add 0.5 to pitch because pitches are plotted with 
+                  // height = PITCH_HEIGHT; thus, the center is raised 
+                  // by PITCH_HEIGHT * 0.5
+                  int y = track->PitchToY(note->pitch);
+                  long linecolor = LookupIntAttribute(note, linecolori, -1);
+                  long linethick = LookupIntAttribute(note, linethicki, 1);
+                  long fillcolor = -1;
+                  long fillflag = 0;
+
+                  // set default color to be that of channel
+                  AColor::MIDIChannel(&dc, note->chan+1);
+                  if (shape != text) {
+                     if (linecolor != -1)
+                        dc.SetPen(wxPen(wxColour(RED(linecolor), 
+                              GREEN(linecolor),
+                              BLUE(linecolor)),
+                              linethick, wxSOLID));
+                  }
+                  if (shape != line) {
+                     fillcolor = LookupIntAttribute(note, fillcolori, -1);
+                     fillflag = LookupLogicalAttribute(note, filll, false);
+
+                     if (fillcolor != -1) 
+                        dc.SetBrush(wxBrush(wxColour(RED(fillcolor),
+                              GREEN(fillcolor),
+                              BLUE(fillcolor)),
+                              wxSOLID));
+                     if (!fillflag) dc.SetBrush(*wxTRANSPARENT_BRUSH);
+                  }
+                  int y1 = track->PitchToY(LookupRealAttribute(note, y1r, note->pitch));
+                  if (shape == line) {
+                     // extreme zooms caues problems under windows, so we have to do some
+                     // clipping before calling display routine
+                     if (x < h) { // clip line on left
+                        y = int((y + (y1 - y) * (h - x) / (x1 - x)) + 0.5);
+                        x = h;
+                     }
+                     if (x1 > h1) { // clip line on right
+                        y1 = int((y + (y1 - y) * (h1 - x) / (x1 - x)) + 0.5);
+                        x1 = h1;
+                     }
+                     AColor::Line(dc, TIME_TO_X(x), y, TIME_TO_X(x1), y1);
+                  } else if (shape == rectangle) {
+                     if (x < h) { // clip on left, leave 10 pixels to spare
+                        x = h - (linethick + 10) / pps;
+                     }
+                     if (x1 > h1) { // clip on right, leave 10 pixels to spare
+                        x1 = h1 + (linethick + 10) / pps;
+                     }
+                     dc.DrawRectangle(TIME_TO_X(x), y, int((x1 - x) * pps + 0.5), y1 - y + 1);
+                  } else if (shape == triangle) {
+                     wxPoint points[3];
+                     points[0].x = TIME_TO_X(x);
+                     CLIP(points[0].x);
+                     points[0].y = y;
+                     points[1].x = TIME_TO_X(LookupRealAttribute(note, x1r, note->pitch));
+                     CLIP(points[1].x);
+                     points[1].y = y1;
+                     points[2].x = TIME_TO_X(LookupRealAttribute(note, x2r, x));
+                     CLIP(points[2].x);
+                     points[2].y = track->PitchToY(LookupRealAttribute(note, y2r, note->pitch));
+                     dc.DrawPolygon(3, points);
+                  } else if (shape == polygon) {
+                     wxPoint points[20]; // upper bound of 20 sides
+                     points[0].x = TIME_TO_X(x);
+                     CLIP(points[0].x);
+                     points[0].y = y;
+                     points[1].x = TIME_TO_X(LookupRealAttribute(note, x1r, x));
+                     CLIP(points[1].x);
+                     points[1].y = y1;
+                     points[2].x = TIME_TO_X(LookupRealAttribute(note, x2r, x));
+                     CLIP(points[2].x);
+                     points[2].y = track->PitchToY(LookupRealAttribute(note, y2r, note->pitch));
+                     int n = 3;
+                     while (n < 20) {
+                        char name[8];
+                        sprintf(name, "x%dr", n);
+                        Alg_attribute attr = symbol_table.insert_string(name);
+                        double xn = LookupRealAttribute(note, attr, -1000000.0);
+                        if (xn == -1000000.0) break;
+                        points[n].x = TIME_TO_X(xn);
+                        CLIP(points[n].x);
+                        sprintf(name, "y%dr", n - 1);
+                        attr = symbol_table.insert_string(name);
+                        double yn = LookupRealAttribute(note, attr, -1000000.0);
+                        if (yn == -1000000.0) break;
+                        points[n].y = track->PitchToY(yn);
+                        n++;
+                     }
+                     dc.DrawPolygon(n, points);
+                  } else if (shape == oval) {
+                     int ix = TIME_TO_X(x);
+                     CLIP(ix);
+                     int ix1 = int((x1 - x) * pps + 0.5);
+                     if (ix1 > CLIP_MAX * 2) ix1 = CLIP_MAX * 2; // CLIP a width
+                     dc.DrawEllipse(ix, y, ix1, y1 - y + 1);
+                  } else if (shape == text) {
+                     if (linecolor != -1)
+                        dc.SetTextForeground(wxColour(RED(linecolor), 
+                              GREEN(linecolor),
+                              BLUE(linecolor)));
+                     // if no color specified, copy color from brush
+                     else dc.SetTextForeground(dc.GetBrush().GetColour());
+
+                     // This seems to have no effect, so I commented it out. -RBD
+                     //if (fillcolor != -1)
+                     //  dc.SetTextBackground(wxColour(RED(fillcolor), 
+                     //                                GREEN(fillcolor),
+                     //                                BLUE(fillcolor)));
+                     //// if no color specified, copy color from brush
+                     //else dc.SetTextBackground(dc.GetPen().GetColour());
+
+                     const char *font = LookupAtomAttribute(note, fonta, NULL);
+                     const char *weight = LookupAtomAttribute(note, weighta, NULL);
+                     int size = LookupIntAttribute(note, sizei, 8);
+                     const char *justify = LookupStringAttribute(note, justifys, "ld");
+                     wxFont wxfont;
+                     wxfont.SetFamily(font == roman ? wxROMAN : 
+                        (font == swiss ? wxSWISS :
+                           (font == modern ? wxMODERN : wxDEFAULT)));
+                     wxfont.SetStyle(wxNORMAL);
+                     wxfont.SetWeight(weight == bold ? wxBOLD : wxNORMAL);
+                     wxfont.SetPointSize(size);
+                     dc.SetFont(wxfont);
+
+                     // now do justification
+                     const char *s = LookupStringAttribute(note, texts, "");
+                     #ifdef __WXMAC__
+                        long textWidth, textHeight;
+                     #else
+                        int textWidth, textHeight;
+                     #endif
+                     dc.GetTextExtent(LAT1CTOWX(s), &textWidth, &textHeight);
+                     long hoffset = 0;
+                     long voffset = -textHeight; // default should be baseline of text
+
+                     if (strlen(justify) != 2) justify = "ld";
+
+                     if (justify[0] == 'c') hoffset = -(textWidth/2);
+                     else if (justify[0] == 'r') hoffset = -textWidth;
+
+                     if (justify[1] == 't') voffset = 0;
+                     else if (justify[1] == 'c') voffset = -(textHeight/2);
+                     else if (justify[1] == 'b') voffset = -textHeight;
+                     if (fillflag) {
+                        // It should be possible to do this with background color,
+                        // but maybe because of the transfer mode, no background is
+                        // drawn. To fix this, just draw a rectangle:
+                        dc.SetPen(wxPen(wxColour(RED(fillcolor), 
+                              GREEN(fillcolor),
+                              BLUE(fillcolor)),
+                              1, wxSOLID));
+                        dc.DrawRectangle(TIME_TO_X(x) + hoffset, y + voffset,
+                              textWidth, textHeight);
+                     }
+                     dc.DrawText(LAT1CTOWX(s), TIME_TO_X(x) + hoffset, y + voffset);
+                  }
+               }
+            }
+         }
+      }
+   }
+   iterator.end();
+   // draw black line between top/bottom margins and the track
+   dc.SetPen(*wxBLACK_PEN);
+   AColor::Line(dc, r.x, r.y + marg, r.x + r.width, r.y + marg);
+   AColor::Line(dc, r.x, r.y + r.height - marg - 1, // subtract 1 to get 
+                r.x + r.width, r.y + r.height - marg - 1); // top of line
+
+   if (h == 0.0 && track->GetOffset() < 0.0) {
+      DrawNegativeOffsetTrackArrows(dc, r);
+   }
+
+   dc.DestroyClippingRegion();
+   SonifyEndNoteForeground();
+}
+
+/* DrawNoteBackground is called by DrawNoteTrack twice: once to draw
+   the unselected background, and once to draw the selected background.
+   The selected background is the same except for the horizontal range
+   and the colors. The background rectangle region is given by r; the
+   selected region is given by sel. The first time this is called,
+   sel is equal to r, and the entire region is drawn with unselected
+   background colors.
+ */
+void NoteTrackV::DrawNoteBackground(NoteTrack *track, wxDC &dc, 
+                                     const wxRect &r, const wxRect &sel, 
+                                     const ViewInfo *viewInfo,
+                                     const wxBrush &wb, const wxPen &wp,
+                                     const wxBrush &bb, const wxPen &bp,
+                                     const wxPen &mp)
+{
+   dc.SetBrush(wb);
+   dc.SetPen(wp);
+   dc.DrawRectangle(sel); // fill rectangle with white keys background
+   double h = viewInfo->h;
+   double pps = viewInfo->zoom;
+
+   int left = TIME_TO_X(track->GetOffset());
+   if (left < sel.x) left = sel.x; // clip on left
+
+   int right = TIME_TO_X(track->GetOffset() + track->mSeq->get_real_dur());
+   if (right > sel.x + sel.width) right = sel.x + sel.width; // clip on right
+
+   // need overlap between MIDI data and the background region
+   if (left >= right) return;
+
+   dc.SetBrush(bb);
+   int octave = 0;
+   // obottom is the window coordinate of octave divider line
+   int obottom = track->GetOctaveBottom(octave);
+   // eOffset is for the line between E and F; there's another line
+   // between B and C, hence the offset of 2 for two line thicknesses
+   int eOffset = track->GetPitchHeight() * 5 + 2;
+   while (obottom > r.y + track->GetNoteMargin() + 3) {
+      // draw a black line separating octaves if this octave botton is visible
+      if (obottom < r.y + r.height - track->GetNoteMargin()) {
+         dc.SetPen(*wxBLACK_PEN);
+         // obottom - 1 because obottom is at the bottom of the line
+         AColor::Line(dc, left, obottom - 1, right, obottom - 1);
+      }
+      dc.SetPen(bp);
+      // draw a black-key stripe colored line separating E and F if visible
+      if (obottom - eOffset > r.y && obottom - eOffset < r.y + r.height) {
+         AColor::Line(dc, left, obottom - eOffset, 
+                          right, obottom - eOffset);
+      }
+
+      // draw visible black key lines
+      wxRect br;
+      br.x = left;
+      br.width = right - left;
+      br.height = track->GetPitchHeight();
+      for (int black = 0; black < 5; black++) {
+         br.y = obottom - track->GetBlackPos(black);
+         if (br.y > r.y && br.y + br.height < r.y + r.height) {
+            dc.DrawRectangle(br); // draw each black key background stripe
+         }
+      }
+      obottom = track->GetOctaveBottom(++octave);
+   }
+
+   // draw bar lines
+   Alg_seq_ptr seq = track->mSeq;
+   // We assume that sliding a NoteTrack around slides the barlines
+   // along with the notes. This means that when we write out a track
+   // as Allegro or MIDI without the offset, we'll need to insert an
+   // integer number of measures of silence, using tempo change to
+   // match the duration to the offset.
+   // Iterate over all time signatures to generate beat positions of
+   // bar lines, map the beats to times, map the times to position,
+   // and draw the bar lines that fall within the region of interest (sel)
+   // seq->convert_to_beats();
+   dc.SetPen(mp);
+   Alg_time_sigs &sigs = seq->time_sig;
+   int i = 0; // index into ts[]
+   double next_bar_beat = 0.0;
+   double beats_per_measure = 4.0;
+   while (true) {
+      if (i < sigs.length() && sigs[i].beat < next_bar_beat + ALG_EPS) {
+         // new time signature takes effect
+         Alg_time_sig &sig = sigs[i++];
+         next_bar_beat = sig.beat;
+         beats_per_measure = (sig.num * 4.0) / sig.den;
+      }
+      // map beat to time
+      double t = seq->get_time_map()->beat_to_time(next_bar_beat);
+      // map time to position
+      int x = TIME_TO_X(t + track->GetOffset());
+      if (x > right) break;
+      AColor::Line(dc, x, sel.y, x, sel.y + sel.height);
+      next_bar_beat += beats_per_measure;
+   }
+}
+
+// returns NULL if note is not a shape,
+// returns atom (string) value of note if note is a shape
+const char *IsShape(Alg_note_ptr note)
+{
+  Alg_parameters_ptr parameters = note->parameters;
+  while (parameters) {
+    if (strcmp(parameters->parm.attr_name(), "shapea") == 0) {
+      return parameters->parm.a;
+    }
+    parameters = parameters->next;
+  }
+  return NULL;
+}
+
+// returns value of attr, or default if not found
+double LookupRealAttribute(Alg_note_ptr note, Alg_attribute attr, double def)
+{
+  Alg_parameters_ptr parameters = note->parameters;
+  while (parameters) {
+    if (parameters->parm.attr_name() == attr + 1 &&
+        parameters->parm.attr_type() == 'r') {
+      return parameters->parm.r;
+    }
+    parameters = parameters->next;
+  }
+  return def;
+}
+
+// returns value of attr, or default if not found
+long LookupIntAttribute(Alg_note_ptr note, Alg_attribute attr, long def)
+{
+  Alg_parameters_ptr parameters = note->parameters;
+  while (parameters) {
+    if (parameters->parm.attr_name() == attr + 1 &&
+        parameters->parm.attr_type() == 'i') {
+      return parameters->parm.i;
+    }
+    parameters = parameters->next;
+  }
+  return def;
+}
+
+// returns value of attr, or default if not found
+bool LookupLogicalAttribute(Alg_note_ptr note, Alg_attribute attr, bool def)
+{
+  Alg_parameters_ptr parameters = note->parameters;
+  while (parameters) {
+    if (parameters->parm.attr_name() == attr + 1 &&
+        parameters->parm.attr_type() == 'l') {
+      return parameters->parm.l;
+    }
+    parameters = parameters->next;
+  }
+  return def;
+}
+
+// returns value of attr, or default if not found
+const char *LookupStringAttribute(Alg_note_ptr note, Alg_attribute attr, const char *def)
+{
+  Alg_parameters_ptr parameters = note->parameters;
+  while (parameters) {
+    if (parameters->parm.attr_name() == attr + 1 &&
+        parameters->parm.attr_type() == 's') {
+      return parameters->parm.s;
+    }
+    parameters = parameters->next;
+  }
+  return def;
+}
+
+// returns value of attr, or default if not found
+const char *LookupAtomAttribute(Alg_note_ptr note, Alg_attribute attr, char *def)
+{
+  Alg_parameters_ptr parameters = note->parameters;
+  while (parameters) {
+    if (parameters->parm.attr_name() == attr + 1 &&
+        parameters->parm.attr_type() == 'a') {
+      return parameters->parm.s;
+    }
+    parameters = parameters->next;
+  }
+  return def;
+}
+#endif // USE_MIDI
+
+
Index: src/view/NoteTrackV.h
===================================================================
--- src/view/NoteTrackV.h	(revision 0)
+++ src/view/NoteTrackV.h	(working copy)
@@ -0,0 +1,25 @@
+
+#ifdef USE_MIDI
+
+class AUDACITY_DLL_API NoteTrackV:
+virtual public TrackV
+{
+public:
+   NoteTrackV(void);
+   ~NoteTrackV(void);
+
+   void DrawNoteTrack(NoteTrack *track,
+                      wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
+                      bool muted);
+
+   void DrawNoteBackground(NoteTrack *track, wxDC &dc, 
+                           const wxRect &r, const wxRect &sel,
+                           const ViewInfo *viewInfo,
+                           const wxBrush &wb, const wxPen &wp,
+                           const wxBrush &bb, const wxPen &bp,
+                           const wxPen &mp);
+
+   int GetBottom(NoteTrack *t, const wxRect &r);
+};
+
+#endif // USE_MIDI
